diff -uNrd ircd-hybrid-6.0/src/s_stats.c ircd-pi1.0a/src/s_stats.c
--- ircd-hybrid-6.0/src/s_stats.c	Fri Jul 30 16:10:54 1999
+++ ircd-pi1.0a/src/s_stats.c	Fri Nov  2 19:23:43 2001
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *  $Id: s_stats.c,v 1.1 1999/07/30 20:10:54 tomh Exp $
+ *  $Id: s_stats.c,v 1.1.1.1 2001/11/03 00:23:43 shifty Exp $
  */
 #include "s_stats.h"
 #include "client.h"
diff -uNrd ircd-hybrid-6.0/src/s_user.c ircd-pi1.0a/src/s_user.c
--- ircd-hybrid-6.0/src/s_user.c	Sat Dec 30 19:12:02 2000
+++ ircd-pi1.0a/src/s_user.c	Thu May 23 00:22:22 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *  $Id: s_user.c,v 1.230 2000/12/31 00:12:02 lusky Exp $
+ *  $Id: s_user.c,v 1.11 2002/05/23 04:22:22 smoli Exp $
  */
 #include "s_user.h"
 #include "channel.h"
@@ -47,6 +47,7 @@
 #include "struct.h"
 #include "whowas.h"
 #include "flud.h"
+#include "config.h"
 
 #ifdef ANTI_DRONE_FLOOD
 #include "dbuf.h"
@@ -68,8 +69,8 @@
 static int do_user (char *, aClient *, aClient*, char *, char *, char *,
                      char *);
 
+int valid_hostname(const char* hostname);
 static int nickkilldone(aClient *, aClient *, int, char **, time_t, char *);
-static int valid_hostname(const char* hostname);
 static int valid_username(const char* username);
 static void report_and_set_user_flags( aClient *, aConfItem * );
 static int tell_user_off(aClient *,char **);
@@ -81,6 +82,9 @@
   {FLAGS_BOTS,  'b'},
   {FLAGS_CCONN, 'c'},
   {FLAGS_DEBUG, 'd'},
+#ifdef ENFORCE
+  {FLAGS_ENFORCE, 'e'},
+#endif /* ENFORCE */
   {FLAGS_FULL,  'f'},
   {FLAGS_INVISIBLE, 'i'},
   {FLAGS_SKILL, 'k'},
@@ -89,6 +93,9 @@
   {FLAGS_LOCOP, 'O'},
   {FLAGS_REJ, 'r'},
   {FLAGS_SERVNOTICE, 's'},
+#ifdef HAVE_SSL
+  {FLAGS_SSLU, 'S'},
+#endif
   {FLAGS_WALLOP, 'w'},
   {FLAGS_EXTERNAL, 'x'},
   {FLAGS_SPY, 'y'},
@@ -123,7 +130,11 @@
   0,            /* P */
   0,            /* Q */
   0,            /* R */
+#ifdef HAVE_SSL
+  FLAGS_SSLU,   /* S */
+#else
   0,            /* S */
+#endif
   0,            /* T */
   0,            /* U */
   0,            /* V */
@@ -137,7 +148,11 @@
   FLAGS_BOTS,   /* b */
   FLAGS_CCONN,  /* c */
   FLAGS_DEBUG,  /* d */
+#ifdef ENFORCE
+  FLAGS_ENFORCE,/* e */
+#else
   0,            /* e */
+#endif /* ENFORCE */
   FLAGS_FULL,   /* f */
   0,            /* g */
   0,            /* h */
@@ -239,6 +254,9 @@
   static long last_time=0;
   static int    s_count = 0, c_count = 0, u_count = 0, i_count = 0;
   static int    o_count = 0, m_client = 0, m_server = 0;
+#ifdef HAVE_SSL
+  static int    ls_count, rs_count;
+#endif
   int forced;
   struct Client *acptr;
 
@@ -255,6 +273,11 @@
   c_count  = Count.total-Count.invisi;
   s_count  = Count.server;
   o_count  = Count.oper;
+#ifdef HAVE_SSL
+  ls_count = Count.local_ssl;
+  rs_count = Count.reach_ssl;
+#endif
+  
   if (forced || (CurrentTime > last_time+LUSERS_CACHE_TIME))
     {
       last_time = CurrentTime;
@@ -262,7 +285,10 @@
       /* use LUSERS_CACHE_TIME instead... */
       s_count = 0; c_count = 0; u_count = 0; i_count = 0;
       o_count = 0; m_client = 0; m_server = 0;
-
+#ifdef HAVE_SSL
+      ls_count = 0; rs_count = 0;
+#endif
+      
       for (acptr = GlobalClientList; acptr; acptr = acptr->next)
         {
           switch (acptr->status)
@@ -276,6 +302,15 @@
             case STAT_CLIENT:
               if (IsAnOper(acptr))
                 o_count++;
+#ifdef HAVE_SSL
+              if(IsSSLUmode(acptr))
+                {
+                  ls_count++;
+                  
+                  if(MyConnect(acptr))
+                    rs_count++;
+                }
+#endif
 #ifdef  SHOW_INVISIBLE_LUSERS
               if (MyConnect(acptr))
                 m_client++;
@@ -353,6 +388,22 @@
                                  "Oper count off by %d", Count.oper - o_count);
               Count.oper = o_count;
             }
+#ifdef HAVE_SSL
+          if(ls_count != Count.local_ssl)
+            {
+              sendto_realops_flags(FLAGS_DEBUG,
+                                   "Local SSL client count off by %d",
+                                   Count.local - ls_count);
+              Count.local = ls_count;
+            }
+          if(rs_count != Count.reach_ssl)
+            {
+              sendto_realops_flags(FLAGS_DEBUG,
+                                   "Reachable SSL client count off by %d",
+                                   Count.reach_ssl - rs_count);
+              Count.local = rs_count;
+            }
+#endif          
           Count.unknown = u_count;
         } /* Complain & reset loop */
     } /* Recount loop */
@@ -385,7 +436,15 @@
              Count.local, Count.max_loc);
   sendto_one(sptr, form_str(RPL_GLOBALUSERS), me.name, parv[0],
              Count.total, Count.max_tot);
-
+#ifdef HAVE_SSL
+  if(MyConnect(sptr) && IsSSL(sptr))
+    {
+      sendto_one(sptr, form_str(RPL_LOCALSSL), me.name, parv[0],
+                 Count.local_ssl, Count.max_loc_ssl);
+      sendto_one(sptr, form_str(RPL_REACHSSL), me.name, parv[0],
+                 Count.reach_ssl, Count.max_rch_ssl);
+    }
+#endif
   sendto_one(sptr, form_str(RPL_STATSCONN), me.name, parv[0],
              MaxConnectionCount, MaxClientCount,
              Count.totalrestartcount);
@@ -538,7 +597,7 @@
   parv[1] = parv[2] = NULL;
 
   /* pointed out by Mortiis, never be too careful */
-  if(strlen(username) > USERLEN)
+  if(irclen(username) > USERLEN)
     username[USERLEN] = '\0';
 
   reason = NULL;
@@ -671,7 +730,7 @@
         }
 
       /* password check */
-      if (!BadPtr(aconf->passwd) && 0 != strcmp(sptr->passwd, aconf->passwd))
+      if (!BadPtr(aconf->passwd) && !strcmp(sptr->passwd, aconf->passwd))
         {
           ServerStats->is_ref++;
           sendto_one(sptr, form_str(ERR_PASSWDMISMATCH),
@@ -775,11 +834,16 @@
          }
 
       sendto_realops_flags(FLAGS_CCONN,
+ #ifdef HAVE_SSL
+                         "%s client connecting: %s (%s@%s) [%s] {%d}",
+                         IsSSL(sptr) ? "SSL" : "Plaintext",
+ #else
                          "Client connecting: %s (%s@%s) [%s] {%d}",
+ #endif
                          nick, sptr->username, sptr->host,
                          inetntoa((char *)&sptr->ip),
                          get_client_class(sptr));
-
+     
       if ((++Count.local) > Count.max_loc)
         {
           Count.max_loc = Count.local;
@@ -787,6 +851,12 @@
             sendto_ops("New Max Local Clients: %d",
                        Count.max_loc);
         }
+      
+#ifdef HAVE_SSL      
+      if(IsSSL(sptr))
+        if(++Count.local_ssl > Count.max_loc_ssl)
+          Count.max_loc_ssl = Count.local;
+#endif
     }
   else
     strncpy_irc(sptr->username, username, USERLEN);
@@ -808,6 +878,13 @@
 /* Increment our total user count here */
   if (++Count.total > Count.max_tot)
     Count.max_tot = Count.total;
+  
+#ifdef HAVE_SSL
+  if((IsServer(cptr) && IsSSLUmode(sptr)) ||
+     (!IsServer(cptr) && IsSSL(cptr)))
+    if(++Count.reach_ssl > Count.max_rch_ssl)
+      Count.max_rch_ssl = Count.reach_ssl;
+#endif
 
   if (MyConnect(sptr))
     {
@@ -817,11 +894,13 @@
                  get_listener_name(sptr->listener), version);
       
       /*
-      ** Don't mess with this one - IRCII needs it! -Avalon
-      */
-      sendto_one(sptr,
+       * Don't mess with this one - IRCII needs it! -Avalon
+       *
+       * blah?
+       */
+/*      sendto_one(sptr,
                  "NOTICE %s :*** Your host is %s, running version %s",
-                 nick, get_listener_name(sptr->listener), version);
+                 nick, get_listener_name(sptr->listener), version);*/
       
       sendto_one(sptr, form_str(RPL_CREATED),me.name,nick,creation);
       sendto_one(sptr, form_str(RPL_MYINFO), me.name, parv[0],
@@ -961,7 +1040,7 @@
  * NOTE: this doesn't allow a hostname to begin with a dot and
  * will not allow more dots than chars.
  */
-static int valid_hostname(const char* hostname)
+int valid_hostname(const char* hostname)
 {
   int         dots  = 0;
   int         chars = 0;
@@ -1342,6 +1421,23 @@
    * parc == 9 on a normal TS style server-to-server NICK
    *      introduction
    */
+#ifdef HAVE_SSL
+  if(IsServer(sptr) && parc == 9 && (s = strchr(parv[4], 'S')))
+    {
+      if(IsSSL(cptr))
+        SetSSLUmode(sptr);
+      else
+        {
+          sendto_realops_flags(FLAGS_DEBUG,
+                               "Remote NICK from unencrypted link %s for user %s, stripping SSL flags...",
+                               cptr->name, parv[1]);
+          do
+            *s = s[1];
+          while(*s++ != '\0');
+        }
+    }
+#endif
+  
   if ((IsServer(sptr)) && (parc < 9))
     {
       /*
@@ -1393,7 +1489,7 @@
    * and KILL it. -avalon 4/4/92
    */
   if (clean_nick_name(nick) == 0 ||
-      (IsServer(cptr) && strcmp(nick, parv[1])))
+      (IsServer(cptr) && irccmp(nick, parv[1])))
     {
       sendto_one(sptr, form_str(ERR_ERRONEUSNICKNAME),
                  me.name, BadPtr(parv[0]) ? "*" : parv[0], parv[1]);
@@ -1497,7 +1593,7 @@
   */
   if (acptr == sptr)
    {
-    if (strcmp(acptr->name, nick) != 0)
+    if (irccmp(acptr->name, nick) != 0)
       /*
       ** Allows change of case in his/her nick
       */
@@ -1804,7 +1900,7 @@
 */
 int m_user(aClient* cptr, aClient* sptr, int parc, char *parv[])
 {
-#define UFLAGS  (FLAGS_INVISIBLE|FLAGS_WALLOP|FLAGS_SERVNOTICE)
+#define UFLAGS  (FLAGS_INVISIBLE|FLAGS_WALLOP|FLAGS_SERVNOTICE|FLAGS_SSLU)
   char* username;
   char* host;
   char* server;
@@ -1876,6 +1972,10 @@
       sptr->flags |= FLAGS_INVISIBLE;
 #endif
 
+#ifdef HAVE_SSL
+      if(IsSSL(sptr))
+        SetSSLUmode(sptr);
+#endif
 #if 0
       /* Undocumented lame extension to the protocol
        * if user provides a number, the bits set are
@@ -2021,7 +2121,8 @@
                                     FLAGS2_OPER_UNKLINE|
                                     FLAGS2_OPER_GLINE|
                                     FLAGS2_OPER_N|
-                                    FLAGS2_OPER_K);
+                                    FLAGS2_OPER_K|
+                                    FLAGS2_OPER_ENFORCE);
                   while(cur_cptr)
                     {
                       if(sptr == cur_cptr) 
@@ -2075,6 +2176,52 @@
       sptr->umodes &= ~FLAGS_NCHANGE; /* only tcm's really need this */
     }
 
+#ifdef HAVE_SSL
+  if((sptr->umodes & FLAGS_SSLU) && !IsSSL(cptr))
+    {
+      sptr->umodes &= ~FLAGS_SSLU;
+
+      if(MyConnect(sptr) && !(setflags & FLAGS_SSLU))
+        sendto_one(sptr,":%s NOTICE %s :You need SSL connection for +S",
+                   me.name, parv[0]);
+    }
+  else if(!(sptr->umodes & FLAGS_SSLU) && (setflags & FLAGS_SSLU) && MyConnect(sptr))
+    {
+      sendto_one(sptr, ":%s NOTICE %s :*** Can't remove SSL usermode",
+                 me.name, parv[0]);
+      sptr->umodes |= FLAGS_SSLU;
+    }
+#endif
+#ifdef ENFORCE
+  if((sptr->umodes & FLAGS_ENFORCE) && !(setflags & FLAGS_ENFORCE))
+    {
+      if(MyConnect(sptr) && !IsOperEnforce(sptr))
+        {
+          sendto_one(sptr, ":%s NOTICE %s :*** You need oper and E flag for +e",
+                     me.name, parv[0]);
+          sptr->umodes &= ~FLAGS_ENFORCE;
+        }
+      else if(MyConnect(sptr))
+#ifdef CUSTOM_ERR
+        sendto_ops("%s (%s@%s) has become an absolute fuck-face (+e)", parv[0],
+#else
+        sendto_ops("%s (%s@%s) has entered full privilege mode (+e)", parv[0],
+#endif /* CUSTOM_ERR */
+                   sptr->username, sptr->host);
+    }
+      
+  if(!(sptr->umodes & FLAGS_ENFORCE) && (setflags & FLAGS_ENFORCE))
+        
+    if(MyConnect(sptr))
+#ifdef CUSTOM_ERR
+      sendto_ops("%s (%s@%s) has returned to normal life (-e)", parv[0],
+#else
+      sendto_ops("%s (%s@%s) has left full privilege mode (-e)", parv[0],
+#endif /* CUSTOM_ERR */
+                 sptr->username, sptr->host);
+
+#endif /* shifty  rel. pi-0.1 */
+
   if (!(setflags & FLAGS_INVISIBLE) && IsInvisible(sptr))
     ++Count.invisi;
   if ((setflags & FLAGS_INVISIBLE) && !IsInvisible(sptr))
@@ -2188,9 +2335,9 @@
  * Annoy/OJNKbots:      "user foo . . :foo"   (disabled)
  * Spambots that are based on OJNK: "user foo x x :foo"
  */
-  if (!strcmp(host,"1")) return 1;
-  if (!strcmp(host,"null")) return 2;
-  if (!strcmp(host, "x")) return 3;
+  if (!irccmp(host,"1")) return 1;
+  if (!irccmp(host,"null")) return 2;
+  if (!irccmp(host, "x")) return 3;
 
   return 0;
 }
diff -uNrd ircd-hybrid-6.0/src/s_zip.c ircd-pi1.0a/src/s_zip.c
--- ircd-hybrid-6.0/src/s_zip.c	Fri Nov 24 13:24:37 2000
+++ ircd-pi1.0a/src/s_zip.c	Fri May 10 23:49:05 2002
@@ -16,8 +16,10 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: s_zip.c,v 1.24 2000/11/24 18:24:37 lusky Exp $
+ *   $Id: s_zip.c,v 1.5 2002/05/11 03:49:05 smoli Exp $
  */
+#define S_ZIP
+
 #include "s_zip.h"
 #include "client.h"
 #include "irc_string.h"
@@ -267,7 +269,7 @@
       break;
 
     case Z_DATA_ERROR: /* the buffer might not be compressed.. */
-      if ((IsCapable(cptr, CAP_ZIP))  && !strncmp("ERROR ", buffer, 6))
+      if ((IsCapable(cptr, CAP_ZIP))  && !ircncmp("ERROR ", buffer, 6))
         {
           cptr->flags2 &= ~FLAGS2_ZIP;
           cptr->caps &= ~CAP_ZIP;
diff -uNrd ircd-hybrid-6.0/src/scache.c ircd-pi1.0a/src/scache.c
--- ircd-hybrid-6.0/src/scache.c	Sun Aug  1 02:47:24 1999
+++ ircd-pi1.0a/src/scache.c	Fri May 10 23:49:05 2002
@@ -1,7 +1,7 @@
 /*
  * scache.c
  *
- * $Id: scache.c,v 1.16 1999/08/01 06:47:24 tomh Exp $
+ * $Id: scache.c,v 1.2 2002/05/11 03:49:05 smoli Exp $
  */
 
 #include "client.h"
@@ -106,7 +106,7 @@
         {
           *number_servers_cached = *number_servers_cached + 1;
           *mem_servers_cached = *mem_servers_cached +
-            (strlen(scache_ptr->name) +
+            (irclen(scache_ptr->name) +
              sizeof(SCACHE *));
 
           scache_ptr = scache_ptr->next;
diff -uNrd ircd-hybrid-6.0/src/send.c ircd-pi1.0a/src/send.c
--- ircd-hybrid-6.0/src/send.c	Sat Dec 30 19:12:03 2000
+++ ircd-pi1.0a/src/send.c	Wed May 22 08:00:22 2002
@@ -17,7 +17,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: send.c,v 1.98 2000/12/31 00:12:03 lusky Exp $
+ *   $Id: send.c,v 1.8 2002/05/22 12:00:22 smoli Exp $
  */
 #include "send.h"
 #include "channel.h"
@@ -87,7 +87,10 @@
   DBufClear(&to->sendQ);
   if (!IsPerson(to) && !IsUnknown(to) && !(to->flags & FLAGS_CLOSING))
     sendto_realops(notice, get_client_name(to, MASK_IP));
-  
+#ifdef BACKUP
+  backup_lost_link(to);
+#endif /* BACKUP */
+
   Debug((DEBUG_ERROR, notice, get_client_name(to, MASK_IP)));
 
   return (-1);
@@ -862,7 +865,6 @@
     {
       if (cptr == from)
         continue;
-      
       vsendto_one(cptr, pattern, args);
     }
 
@@ -995,7 +997,7 @@
               (void)ircsprintf(nbuf, ":%s NOTICE %s :*** Notice -- ",
                                me.name, cptr->name);
       
-              (void)strncat(nbuf, pattern, sizeof(nbuf) - strlen(nbuf));
+              (void)strncat(nbuf, pattern, sizeof(nbuf) - irclen(nbuf));
       
               vsendto_one(cptr, nbuf, args);
             }
@@ -1014,7 +1016,7 @@
               (void)ircsprintf(nbuf, ":%s NOTICE %s :*** Notice -- ",
                                me.name, cptr->name);
               
-              (void)strncat(nbuf, pattern, sizeof(nbuf) - strlen(nbuf));
+              (void)strncat(nbuf, pattern, sizeof(nbuf) - irclen(nbuf));
               
               vsendto_one(cptr, nbuf, args);
             }
@@ -1045,7 +1047,7 @@
         {
           (void)ircsprintf(nbuf, ":%s NOTICE %s :*** Notice -- ",
                            me.name, cptr->name);
-          (void)strncat(nbuf, pattern, sizeof(nbuf) - strlen(nbuf));
+          (void)strncat(nbuf, pattern, sizeof(nbuf) - irclen(nbuf));
           
           vsendto_one(cptr, nbuf, args);
         }
@@ -1100,6 +1102,7 @@
   va_end(args);
 } /* sendto_ops_butone() */
 
+
 /*
 ** sendto_wallops_butone
 **      Send message to all operators.
@@ -1149,6 +1152,32 @@
         va_end(args);
 } /* sendto_wallops_butone() */
 
+/* send a message to ALL local clients */
+void
+sendto_myclients(aClient *from, const char *pattern, ...)
+{
+  aClient *cptr;
+  char nbuf[1024];
+  va_list args;
+  
+  va_start(args, pattern);
+  
+  for(cptr = local_cptr_list; cptr; cptr = cptr->next_local_client)
+    {
+      if(!IsPerson(cptr))
+        continue;
+      
+      ircsprintf(nbuf, ":%s!%s@%s NOTICE %s :*** Global -- ",
+                 from->name, from->username, from->host, cptr->name);
+            
+      strncat(nbuf, pattern, sizeof(nbuf) - irclen(nbuf));
+                
+      vsendto_one(cptr, nbuf, args);
+    }
+  
+  va_end(args);
+}
+
 /*
 ** send_operwall -- Send Wallop to All Opers on this server
 **
@@ -1298,7 +1327,7 @@
   *sendbuf = ':';
   strncpy_irc(sendbuf + 1, par, sizeof(sendbuf) - 2);
 
-  parlen = strlen(par) + 1;
+  parlen = irclen(par) + 1;
   sendbuf[parlen++] = ' ';
 
   len = parlen;
@@ -1342,6 +1371,24 @@
   va_end(args);
 } /* sendto_realops() */
 
+void
+sendto_realops_lev(int priority, const char *pattern, ...)
+
+{
+  va_list args;
+
+  assert(-1 < priority);
+
+  va_start(args, pattern);
+  
+  if(priority > get_log_level())
+    return;
+  
+  vsendto_realops(pattern, args);
+
+  va_end(args);
+} /* sendto_realops() */
+
 /*
 vsendto_realops()
  Send the given string to local operators (not +s)
@@ -1360,7 +1407,7 @@
         {
           (void)ircsprintf(nbuf, ":%s NOTICE %s :*** Notice -- ",
                            me.name, cptr->name);
-          (void)strncat(nbuf, pattern, sizeof(nbuf) - strlen(nbuf));
+          (void)strncat(nbuf, pattern, sizeof(nbuf) - irclen(nbuf));
           
           vsendto_one(cptr, nbuf, args);
         }
@@ -1389,7 +1436,7 @@
         {
           (void)ircsprintf(nbuf, ":%s NOTICE %s :*** Notice -- ",
                            me.name, cptr->name);
-          (void)strncat(nbuf, pattern, sizeof(nbuf) - strlen(nbuf));
+          (void)strncat(nbuf, pattern, sizeof(nbuf) - irclen(nbuf));
           
           vsendto_one(cptr, nbuf, args);
         }
diff -uNrd ircd-hybrid-6.0/src/sprintf_irc.c ircd-pi1.0a/src/sprintf_irc.c
--- ircd-hybrid-6.0/src/sprintf_irc.c	Fri Jul 30 21:53:32 1999
+++ ircd-pi1.0a/src/sprintf_irc.c	Sun May  5 00:42:24 2002
@@ -17,7 +17,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: sprintf_irc.c,v 1.9 1999/07/31 01:53:32 tomh Exp $
+ *   $Id: sprintf_irc.c,v 1.4 2002/05/05 04:42:24 smoli Exp $
  */
 #include "sprintf_irc.h"
 
@@ -451,7 +451,7 @@
 ircsprintf(register char *str, const char *format, ...)
 
 {
-        register va_list args;
+        va_list args;
         register int bytes;
 
         va_start(args, format);
